var Newtonian        = require('../../lib/ecs/components/Newtonian.js');
var Position         = require('../../lib/ecs/components/Position.js');
var Camera           = require('../../lib/ecs/components/Camera.js');
var Game             = require('../../lib/Game.js');
var Vec2             = require('../../lib/util/Vec2.js');
var PlayerControlled = require('../components/PlayerControlled.js');
var Targeting        = require('../components/Targeting.js');

// THIS IS ALL SHIT

module.exports = (function() {

    PlayerInput.componentTypes =
        [Newtonian, Position, PlayerControlled];

    PlayerInput.cameraComponent = [Camera];

    PlayerInput.gunFilter = [Targeting];

    // System that monitors game input and translates that into signals
    function PlayerInput()
    {
        this.lastHover = null;
    }

    PlayerInput.prototype.update = function(dt, time)
    {
        var entities = this.entityManager.getEntitiesByComponents(
            PlayerInput.componentTypes);

        var inputs = Game.instance.input.inputs;
        var camera = this.entityManager.getEntitiesByTag('mainCamera')[0];

        // Game gamespace vector of the mouse
        var tPos = Camera.toGameVector(camera, inputs.hover_m.pcopy());

        // Zoom in / out with mouse wheel
        if (inputs.position_wheel) {
            if (inputs.position_wheel == -1 && camera.Camera.scale < 0.2)
                camera.Camera.scale *= 0.9;
            else if (inputs.position_wheel == 1 && camera.Camera.scale < 0.2)
                camera.Camera.scale *= 1.1;
            else
                camera.Camera.scale += inputs.position_wheel * 0.1;
        }

        // Update players
        for (var n = 0; n < entities.length; n++) {
            var player = entities[n];
            var playerToHover = tPos.pcopy()
                .sub(Position.getAbsoluteLocation(player));

            var boosting = !!inputs.button_k_16;

            var rv = Vec2.pfromAngle(player.Position.rotation);

            /*
            var per = player.Newtonian.velocity.magnitude() / player.Newtonian.maxSpeed;
            camera.Camera.scale =
                0.01 * (1 - Math.min(0.7, 0.7 * per)) +
                0.99 * camera.Camera.scale;
            */

            // Controller
            var thrust  = false;
            var rthrust = false;
            var gun1    = false;
            if (inputs.gamepads && inputs.gamepads[0]) {
                var pad = inputs.gamepads[0];
                if (pad.buttons[7]) thrust  = true;
                if (pad.buttons[6]) rthrust = true;
                if (pad.buttons[0]) gun1    = true;

                rv.set(pad.axes[0], pad.axes[1]);
                if (rv.magnitude() < 0.2)
                    rv.clear();
            } else {
                rv.assign(playerToHover);
            }

            var trv = Vec2.pfromAngle(player.Position.rotation);
            if (rv.magnitude() > 0.1) {
                var det = rv.det(trv);
                var diff = Math.abs(rv.angleBetween(trv));
                var speed = 0;
                var maxR = player.Newtonian.maxRadialSpeed;


                if (player.Newtonian.radialRamp) {
                    var cutoff = player.Newtonian.radialRamp;
                    var nm = 1 / cutoff;

                    if (diff < cutoff) {
                        maxR = maxR * diff * nm;
                    }
                }

                var limit = maxR / (1000/dt);

                if (diff > limit) {
                    var r = diff < 0.3 ? maxR : maxR;
                    speed = det < 0 ? r : -r;
                } else {
                    speed = 0;
                    player.Position.rotation = rv.angle();
                }

                player.Newtonian.radialSpeed = speed;

                var guns = this.entityManager.getEntitiesByComponents(PlayerInput.gunFilter);
                for (var h = 0; h < guns.length; h++) {
                    var entity = guns[h];
                    entity.Targeting.targetingStrategy = 'trackAngle';
                    entity.Targeting.targetAngle = rv.angle();
                }

            } else {
                player.Newtonian.radialSpeed = player.Newtonian.radialSpeed * 0.9;
            }
            Vec2.release(trv);

            var ggs = this.entityManager.getEntitiesByComponents(PlayerInput.gunFilter);
            for (var k = 0; k < ggs.length; k++) {
                var en = ggs[k];
                en.Gun.firing = gun1 || inputs.button_k_32;
            }


            Vec2.release(rv);
            rv = Vec2.pfromAngle(player.Position.rotation);
            if (rthrust && thrust) rthrust = thrust = false;

            if (inputs.button_k_87 || thrust) {
                player.Newtonian.acceleration
                    .assign(rv)
                    .normalize(player.Newtonian.maxAcceleration);
            } else if (inputs.button_k_83 || rthrust) {
                player.Newtonian.acceleration
                    .assign(rv)
                    .rotate(Math.PI)
                    .normalize(player.Newtonian.maxAcceleration);
            } else {
                player.Newtonian.acceleration.clear();

                if (player.Newtonian.velocity.magnitude() > 1)
                    player.Newtonian.velocity.smult(0.99);
                else
                    player.Newtonian.velocity.clear();
            }

            Vec2.release(rv);
            Vec2.release(playerToHover);
        }

        Vec2.release(tPos);
    };

    return PlayerInput;

})();
