var Collision = require('../components/Collision.js');
var Spatial   = require('../components/Spatial.js');
var System    = require('../System.js');
var __extends = require('../../util/extends.js');

module.exports = (function(_super) {
    __extends(Collider, _super);

    Collider.filter = [Collision];

    // Fire coincident events when objects overlap in their Spatial AABBs
    function Collider()
    {
        _super.apply(this, arguments);
    }

    Collider.prototype.update = function(dt, time)
    {
        var entities = this.entityManager.getEntitiesByComponents(
            Collider.filter);

        for (var n = 0; n < entities.length; n++) {
            var entity = entities[n];
            var others = Spatial.getCoincidentEntities(entity);
            if (!others || !others.length) continue;

            entity.trigger(Collision.coincident, others);
        }
    };

    return Collider;

})(System);

