var ExpiryComponent = require('../components/Expiry.js');

module.exports = (function() {

    Expiry.componentTypes = [ExpiryComponent];

    Expiry.expired = 'expired';

    // Remove Expiry components after their life is over
    function Expiry()
    {

    }

    Expiry.prototype.update = function(dt, time)
    {
        var entities = this.entityManager
            .getEntitiesByComponents(Expiry.componentTypes);

        var length = entities.length;
        for (var n = 0; n < length; n++) {
            var entity = entities[n];

            // If an entity has expired, remove it and account for the removal
            // in our list and iterator values
            if(entity.Expiry.expireAt && entity.Expiry.expireAt <= time) {
                entity.trigger(Expiry.expired);
                entity.remove();
                n--;
                length--;
            }
        }
    };

    return Expiry;

})();
