var Newtonian = require('../components/Newtonian.js');
var Position  = require('../components/Position.js');
var Vec2      = require('../../util/Vec2.js');

// System that moves Newtonian components around based on their current
// velocity without taking into account any sort of collision mechanics
module.exports = (function() {

    // Hint to the game on indexes we need
    Mover.componentTypes = [Position, Newtonian];

    function Mover()
    {

    }

    Mover.prototype.update = function(dt, time)
    {
        var entities = this.entityManager
            .getEntitiesByComponents(Mover.componentTypes);

        // Simply move the x/y specified by the velocity
        var v = Vec2.aquire();
        for (var n = 0; n < entities.length; n++) {
            var entity = entities[n];
            v.assign(entity.Newtonian.velocity);
            entity.Position.location.add(v.smult(dt / 1000));
        }
        Vec2.release(v);
    };

    return Mover;

})();
