var EntityManager = require('../ecs/EntityManager.js');
var SystemManager = require('../ecs/SystemManager.js');

module.exports = (function() {

    // Layer used to maintain an entity system
    function EntityLayer()
    {
        this.entityManager = new EntityManager();
        this.systemManager = new SystemManager(this.entityManager);
    }

    // Get the indexed entites for each system and let them process
    EntityLayer.prototype.update = function(dt, time)
    {
        this.systemManager.updateAll(dt, time);
    };

    return EntityLayer;

})();
