var Canvas = require('./Canvas.js');

module.exports = (function() {

    // Manage the screen canvas if we need to get to it
    function ScreenManager()
    {
        this.screen = new Canvas(); // will get thrown away on screen creation
        this.createScreen();
    }

    // Create the canvas element and add it to the body
    ScreenManager.prototype.createScreen = function(width, height)
    {
        width = width || global.innerWidth;
        height = height || global.innerHeight;
        var aspect = width / height;

        // Create a canvas and convert to a Canvas wrapper
        var el = navigator.isCocoon ? 'screencanvas' : 'canvas';
        var screen = document.createElement(el);
        this.screen = screen = new Canvas(screen);
        screen.resize(width, height);

        if (navigator.isCocoon)
            screen._canvas.setAttribute('screencanvas', 'true');

        document.body.style.background = 'black';
        document.body.appendChild(screen._canvas);

        return screen;
    };

    return ScreenManager;

})();
