var EntityManager = require('../../lib/ecs/EntityManager');
var Attached      = require('../../lib/ecs/components/Attached');
var Position      = require('../../lib/ecs/components/Position');
var Vec2          = require('../../lib/util/Vec2');

QUnit.module('Attached component');

test('Relative position from attached entities', function() {
    var real;
    var m = new EntityManager();

    var e = m.addNewEntity();
    e.addComponent(Position);

    var child = m.addNewEntity();
    child.addComponent(Position);
    child.addComponent(Attached);
    child.Attached.parentEntity = e;

    real = Position.getAbsoluteLocation(child);
    strictEqual(real.x, 0, 'legit');
    strictEqual(real.y, 0, 'legit');

    e.Position.location = new Vec2(2, 3);
    real = Position.getAbsoluteLocation(child);
    strictEqual(real.x, 2, 'legit');
    strictEqual(real.y, 3, 'legit');
    real = Position.getAbsoluteLocation(e);
    strictEqual(real.x, 2, 'legit');
    strictEqual(real.y, 3, 'legit');

    child.Position.location.x = 5; child.Position.location.y = 2;
    real = Position.getAbsoluteLocation(child);
    strictEqual(real.x, 7, 'legit');
    strictEqual(real.y, 5, 'legit');
    real = Position.getAbsoluteLocation(e);
    strictEqual(real.x, 2, 'legit');
    strictEqual(real.y, 3, 'legit');

});
