var Pool = require('../../lib/util/Pool');
var Vec2 = require('../../lib/util/Vec2');

QUnit.module('Object Pool');

test('basics', function() {

    var pool = new Pool(Vec2);

    strictEqual(pool.count, 1, '1 initialized');
    var v = pool.aquire();
    strictEqual(pool.count, 1, '1 after inital request');
    strictEqual(pool.freeList.length, 0, '1 free');
    var v2 = pool.aquire();
    strictEqual(pool.freeList.length, 0, '2 free');
    strictEqual(pool.count, 2, '3 after second');

    pool.release(v);
    pool.release(v2);
    strictEqual(pool.freeList.length, 2, '3 free');
    strictEqual(pool.count, 2, '3 after second');

});

test('object reseting', function() {

    var pool = new Pool(Vec2);

    var v = pool.aquire();
    v.x = 5;
    v.y = 10;
    pool.release(v);
    var v2 = pool.aquire();

    strictEqual(v, v2, 'objects are the same');
    strictEqual(v2.x, 0, 'x reset');
    strictEqual(v2.y, 0, 'y reset');

});

